#!/usr/bin/perl
# $Id: change-channel.pl 326 2008-09-17 17:33:19Z bd $

use Getopt::Long;

my $PATHPREFIX = "/usr/local/glotv";

my ($opt_chan);
GetOptions('channel=s' => \$opt_chan);

open CHAN, '>', "$PATHPREFIX/var/dvb-requested-channel"
    or die "Couldn't write to $PATHPREFIX/var/dvb-requested-channel: $!";
print CHAN $opt_chan,"\n";
close CHAN;

if (open CHAN, '<', "$PATHPREFIX/var/dvb-playing-channel") {
    my $playing_chan = <CHAN>;
    close CHAN;
    chomp $playing_chan;
    if ($chan ne $playing_chan) {
	if (open PID, '<', "$PATHPREFIX/var/dvb-play.pid") {
	    my $pid = <PID>;
	    close PID;
	    chomp $pid;
	    if ($pid) {
		kill 'SIGHUP', $pid;
	    }
	}
    }
}

