#!/usr/bin/perl
# $Id: sysfs-status.pl 357 2016-03-28 18:47:04Z bd $

my @ids = split(/\s+/, `ls -d /sys/class/pvrusb2/*/`);
if (@ids) {
    foreach my $param (qw(input frequency video_bitrate video_bitrate_peak
			  stream_type streaming_enabled)) {
	if (open CTL, "< $ids[0]ctl_$param/cur_val") {
	    my $data = <CTL>;
	    chomp $data;
	    $data = &mangle($param, $data);
	    print STDOUT "$param $data\n";
	    close CTL;
	}
    }
}

sub mangle {
    my $param = shift;
    my $data = shift;
    if ($param eq 'frequency') {
	$data = $data/1000000;
    }
    return $data;
}

1;
